import { IModelType, Instance, ModelPropertiesDeclaration, ModelPropertiesDeclarationToProperties, SnapshotOut } from 'mobx-state-tree';
declare type ModelType<P extends ModelPropertiesDeclaration> = IModelType<ModelPropertiesDeclarationToProperties<P>, {}>;
export declare type Updater<P extends ModelPropertiesDeclaration> = (state: Instance<ModelType<P>>) => void;
export declare type Snapshot<P extends ModelPropertiesDeclaration> = SnapshotOut<ModelType<P>>;
export declare const useMstImmer: <P extends ModelPropertiesDeclaration, MT = ModelType<P>>(props: P, initialState?: any) => [SnapshotOut<MT>, import("mobx-state-tree/dist/internal").STNValue<import("mobx-state-tree").ModelInstanceType<ModelPropertiesDeclarationToProperties<P>, {
    set(updater: Updater<P>): SnapshotOut<MT>;
}>, IModelType<ModelPropertiesDeclarationToProperties<P>, {
    set(updater: Updater<P>): SnapshotOut<MT>;
}, import("mobx-state-tree")._NotCustomized, import("mobx-state-tree")._NotCustomized>>["set"]];
export {};
